#!/usr/bin/env python
#
# (C) 2008 British Broadcasting Corporation and Kamaelia Contributors(1)
#     All Rights Reserved.
#
# You may only modify and redistribute this under the terms of any of the
# following licenses(2): Mozilla Public License, V1.1, GNU General
# Public License, V2.0, GNU Lesser General Public License, V2.1
#
# (1) Kamaelia Contributors are listed in the AUTHORS file and at
#     http://kamaelia.sourceforge.net/AUTHORS - please extend this file,
#     not this notice.
# (2) Reproduced in the COPYING file, and at:
#     http://kamaelia.sourceforge.net/COPYING
# Under section 3.5 of the MPL, we are using this text since we deem the MPL
# notice inappropriate for this file. As per MPL/GPL/LGPL removal of this
# notice is prohibited.
#
# Please contact us via: kamaelia-list-owner@lists.sourceforge.net
# to discuss alternative licensing.
# -------------------------------------------------------------------------

from distutils.core import setup

setup(name = "Kamaelia-GSOC-JMB",
      version = "0.1.0",
      description = "Jason Baker's GSOC work, repackaged as a standalone project.",
      author = "Jason Baker, Michael Sparks & Kamaelia Contributors",
      author_email = "kamaelia@googlegroups.com",
      url = "http://www.kamaelia.org/Developers/Projects/KamaeliaPublish",
      license = "Copyright (c)2008 BBC & Kamaelia Contributors, All Rights Reserved. Use allowed under MPL 1.1, GPL 2.0, LGPL 2.1",
      packages = [\
                  "Axon", ### START
                  "Axon.experimental", ### LAST
                  "Kamaelia", # START
                  "Kamaelia.Apps",
                  "Kamaelia.Apps.Compose",
                  "Kamaelia.Apps.Compose.GUI",
                  "Kamaelia.Apps.Europython09",
                  "Kamaelia.Apps.Europython09.BB",
                  "Kamaelia.Apps.Games4Kids",
                  "Kamaelia.Apps.Grey",
                  "Kamaelia.Apps.GSOCPaint",
		  "Kamaelia.Apps.IRCLogger",
		  "Kamaelia.Apps.JsonRPC",
		  "Kamaelia.Apps.JMB",
		  "Kamaelia.Apps.JMB.Common",
		  "Kamaelia.Apps.JMB.WSGI",
                  "Kamaelia.Apps.JMB.WSGI.Apps",
                  "Kamaelia.Apps.SA",
                  "Kamaelia.Apps.Show",
                  "Kamaelia.Apps.SpeakNWrite",
                  "Kamaelia.Apps.SpeakNWrite.Gestures",
                  "Kamaelia.Apps.Whiteboard",
                  "Kamaelia.Automata",
                  "Kamaelia.Audio",
                  "Kamaelia.Audio.PyMedia",
                  "Kamaelia.Audio.Codec",
                  "Kamaelia.Audio.Codec.PyMedia",
                  "Kamaelia.Chassis",
                  "Kamaelia.Codec",
                  "Kamaelia.Device",
                  "Kamaelia.Device.DVB",
                  "Kamaelia.Device.DVB.Parse",
                  "Kamaelia.Experimental",
                  "Kamaelia.File",
                  "Kamaelia.Internet",
                  "Kamaelia.Internet.Simulate",
                  "Kamaelia.Protocol",
                  "Kamaelia.Protocol.AIM",
                  "Kamaelia.Protocol.HTTP",
                  "Kamaelia.Protocol.HTTP.Handlers",
                  "Kamaelia.Protocol.IRC",
                  "Kamaelia.Protocol.RTP",
                  "Kamaelia.Protocol.Torrent",
                  "Kamaelia.Support",
                  "Kamaelia.Support.Data",
                  "Kamaelia.Support.DVB",
                  "Kamaelia.Support.Particles",
                  "Kamaelia.Support.Protocol",
                  "Kamaelia.Support.PyMedia",
                  "Kamaelia.Support.Tk",
                  "Kamaelia.UI",
                  "Kamaelia.UI.Tk",
                  "Kamaelia.UI.MH",
                  "Kamaelia.UI.Pygame",  
                  "Kamaelia.UI.OpenGL",
                  "Kamaelia.Util",
                  "Kamaelia.Util.Tokenisation",
                  "Kamaelia.Video",
                  "Kamaelia.Visualisation",
                  "Kamaelia.Visualisation.Axon",
                  "Kamaelia.Visualisation.ER",
                  "Kamaelia.Visualisation.PhysicsGraph",
                  "Kamaelia.Visualisation.PhysicsGraph3D",
                  "Kamaelia.XML", # LAST
                  ""],
#      scripts = [ '' ],
#
#      data_files=[ ('/some/dest/dir', ['Config/some_config_file.dist']) ],

      long_description = """
Jason Baker's GSOC work, repackaged as a standalone project.
""",
      )

import sys
if "install" in sys.argv:
    import os
    if os.uname()[0] == "Linux" or os.uname()[0] == "Darwin":
        os.chdir("App/PersonalWsgiServer")
        os.system("./make-unix.sh")
        os.system("cp dist/kwserve /usr/local/bin/personal_wsgi_server")
    else:
        print "Cannot build the personal wsgi server on this platform."
        print "You can probably run it if you fiddle about with it enough though..."
